declare module "apex-shared" {

    export interface Thing {

        _id: string;
        name: string;
        description?: string;
        properties: Array<ThingProperty>;
        actions: Array<ThingAction>;
        events: Array<ThingEvent>;
    }

    export interface ThingProperty {

        name: string;
        description?: string;
        type: "string" | "number" | "boolean";
        unit?: string;
        href: string;
    }

    export interface ThingAction {

        name: string;
        description?: string;
        params?: [{

            name: string;
            description?: string;
            type?: "string" | "number" | "boolean"
        }];
    }

    export interface ThingEvent {

        name: string;
        description?: string;
    }
}